Loading...
Searching...
No Matches
DSRDocument Class Reference

Interface class for 'dcmsr' (DICOM Structured Reporting Documents). More...

Inheritance diagram for DSRDocument:

## Public Member Functions

| DSRDocument (const E_DocumentType documentType=DT_BasicTextSR)
| (default) constructor.
virtual | ~DSRDocument ()
| destructor
virtual void | clear ()
| clear all internal member variables
virtual OFBool | isValid ()
| check whether the current internal state is valid.
virtual OFBool | isFinalized () const
| check whether the document is finalized.
virtual OFCondition | print (STD_NAMESPACE ostream &stream, const size_t flags=0)
| print current SR document to specified output stream.
virtual OFCondition | read (DcmItem &dataset, const size_t flags=0)
| read SR document from DICOM dataset.
virtual OFCondition | readPatientData (DcmItem &dataset, const size_t flags=0)
| read patient data from DICOM dataset.
virtual OFCondition | readStudyData (DcmItem &dataset, const size_t flags=0)
| read study data from DICOM dataset.
virtual OFCondition | write (DcmItem &dataset, DcmStack *markedItems=NULL)
| write current SR document to DICOM dataset.
virtual OFCondition | readXML (const OFString &filename, const size_t flags=0)
| read SR document from XML file.
virtual OFCondition | writeXML (STD_NAMESPACE ostream &stream, const size_t flags=0)
| write current SR document in XML format.
virtual OFCondition | renderHTML (STD_NAMESPACE ostream &stream, const size_t flags=0, const char *styleSheet=NULL, const char *urlPrefix=NULL)
| render current SR document in HTML/XHTML format.
virtual E_DocumentType | getDocumentType () const
| get the current SR document type
DSRDocumentTree & | getTree ()
| get document tree
virtual OFCondition | setTree (const DSRDocumentTree &tree)
| set document tree.
virtual OFCondition | setTreeFromRootTemplate (DSRRootTemplate &rootTemplate, const OFBool expandTree=OFTrue)
| set document tree from root template.
virtual E_CharacterSet | getSpecificCharacterSetType () const
| get specific character set type.
virtual OFCondition | setSpecificCharacterSetType (const E_CharacterSet characterSet)
| set specific character set type.
virtual E_PreliminaryFlag | getPreliminaryFlag () const
| get document preliminary flag.
virtual OFCondition | setPreliminaryFlag (const E_PreliminaryFlag flag)
| set document preliminary flag.
virtual E_CompletionFlag | getCompletionFlag () const
| get document completion flag.
virtual E_VerificationFlag | getVerificationFlag () const
| get document verification flag.
virtual OFBool | hasVerifyingObservers () const
| check whether there are one or more verifying observers.
virtual size_t | getNumberOfVerifyingObservers () const
| get number of verifying observers.
virtual OFCondition | getVerifyingObserver (const size_t idx, OFString &dateTime, OFString &observerName, OFString &organization)
| get information about a verifying observer.
virtual OFCondition | getVerifyingObserver (const size_t idx, OFString &dateTime, OFString &observerName, DSRCodedEntryValue &observerCode, OFString &organization)
| get information about a verifying observer.
virtual DSRSOPInstanceReferenceList & | getPredecessorDocuments ()
| get list of predecessor documents.
virtual DSRSOPInstanceReferenceList & | getIdenticalDocuments ()
| get list of identical documents.
virtual DSRSOPInstanceReferenceList & | getCurrentRequestedProcedureEvidence ()
| get list of referenced SOP instances (Current Requested Procedure Evidence).
virtual DSRSOPInstanceReferenceList & | getPertinentOtherEvidence ()
| get list of referenced SOP instances (Pertinent Other Evidence).
virtual DSRReferencedInstanceList & | getReferencedInstances ()
| get list of referenced SOP instances significantly related to the current SOP instance.
virtual DSRCodingSchemeIdentificationList & | getCodingSchemeIdentification ()
| get list of coding schemes used (Coding Scheme Identification).
virtual OFCondition | getSpecificCharacterSet (OFString &value, const signed long pos=0) const
| get specific character set
virtual OFCondition | getCompletionFlagDescription (OFString &value, const signed long pos=0) const
| get completion flag description.
virtual OFCondition | getModality (OFString &value, const signed long pos=0) const
| get modality
virtual OFCondition | getSOPClassUID (OFString &value, const signed long pos=0) const
| get SOP class UID
virtual OFCondition | getStudyInstanceUID (OFString &value, const signed long pos=0) const
| get study instance UID
virtual OFCondition | getSeriesInstanceUID (OFString &value, const signed long pos=0) const
| get series instance UID
virtual OFCondition | getSOPInstanceUID (OFString &value, const signed long pos=0) const
| get SOP instance UID
virtual OFCondition | getInstanceCreatorUID (OFString &value, const signed long pos=0) const
| get instance creator UID
virtual OFCondition | getTimezoneOffsetFromUTC (OFString &value, const signed long pos=0) const
| get timezone offset from UTC
virtual OFCondition | getPatientName (OFString &value, const signed long pos=0) const
| get patient's name
virtual OFCondition | getPatientBirthDate (OFString &value, const signed long pos=0) const
| get patient's birth date
virtual OFCondition | getPatientSex (OFString &value, const signed long pos=0) const
| get patient's sex
virtual OFCondition | getPatientAge (OFString &value, const signed long pos=0) const
| get patient's age
virtual OFCondition | getPatientSize (OFString &value, const signed long pos=0) const
| get patient's size
virtual OFCondition | getPatientWeight (OFString &value, const signed long pos=0) const
| get patient's weight
virtual OFCondition | getReferringPhysicianName (OFString &value, const signed long pos=0) const
| get referring physician's name
virtual OFCondition | getStudyDescription (OFString &value, const signed long pos=0) const
| get study description
virtual OFCondition | getSeriesDescription (OFString &value, const signed long pos=0) const
| get series description
virtual OFCondition | getProtocolName (OFString &value, const signed long pos=0) const
| get protocol name
virtual OFCondition | getManufacturer (OFString &value, const signed long pos=0) const
| get manufacturer
virtual OFCondition | getManufacturerModelName (OFString &value, const signed long pos=0) const
| get manufacturer's model name
virtual OFCondition | getDeviceSerialNumber (OFString &value, const signed long pos=0) const
| get device serial number
virtual OFCondition | getSoftwareVersions (OFString &value, const signed long pos=0) const
| get software version(s)
virtual OFCondition | getSynchronizationFrameOfReferenceUID (OFString &value, const signed long pos=0) const
| get synchronization frame of reference UID
virtual OFCondition | getSynchronizationTrigger (OFString &value, const signed long pos=0) const
| get synchronization trigger
virtual OFCondition | getAcquisitionTimeSynchronized (OFString &value, const signed long pos=0) const
| get acquisition time synchronized
virtual OFCondition | getStudyDate (OFString &value, const signed long pos=0) const
| get study date
virtual OFCondition | getStudyTime (OFString &value, const signed long pos=0) const
| get study time
virtual OFCondition | getSeriesDate (OFString &value, const signed long pos=0) const
| get series date
virtual OFCondition | getSeriesTime (OFString &value, const signed long pos=0) const
| get series time
virtual OFCondition | getInstanceCreationDate (OFString &value, const signed long pos=0) const
| get instance creation date
virtual OFCondition | getInstanceCreationTime (OFString &value, const signed long pos=0) const
| get instance creation time
virtual OFCondition | getContentDate (OFString &value, const signed long pos=0) const
| get content date
virtual OFCondition | getContentTime (OFString &value, const signed long pos=0) const
| get content time
virtual OFCondition | getStudyID (OFString &value, const signed long pos=0) const
| get study ID
virtual OFCondition | getPatientID (OFString &value, const signed long pos=0) const
| get patient ID
virtual OFCondition | getIssuerOfPatientID (OFString &value, const signed long pos=0) const
| get issuer of patient ID
virtual OFCondition | getSeriesNumber (OFString &value, const signed long pos=0) const
| get series number
virtual OFCondition | getInstanceNumber (OFString &value, const signed long pos=0) const
| get instance number
virtual OFCondition | getAccessionNumber (OFString &value, const signed long pos=0) const
| get accession number
virtual OFCondition | setSpecificCharacterSet (const OFString &value, const OFBool check=OFTrue)
| set specific character set.
virtual OFCondition | setCompletionFlagDescription (const OFString &value, const OFBool check=OFTrue)
| set completion flag description.
virtual OFCondition | setTimezoneOffsetFromUTC (const OFString &value, const OFBool check=OFTrue)
| set timezone offset from UTC
virtual OFCondition | setPatientName (const OFString &value, const OFBool check=OFTrue)
| set patient's name
virtual OFCondition | setPatientBirthDate (const OFString &value, const OFBool check=OFTrue)
| set patient's birth date
virtual OFCondition | setPatientSex (const OFString &value, const OFBool check=OFTrue)
| set patient's sex
virtual OFCondition | setPatientAge (const OFString &value, const OFBool check=OFTrue)
| set patient's age
virtual OFCondition | setPatientSize (const OFString &value, const OFBool check=OFTrue)
| set patient's size
virtual OFCondition | setPatientWeight (const OFString &value, const OFBool check=OFTrue)
| set patient's weight
virtual OFCondition | setReferringPhysicianName (const OFString &value, const OFBool check=OFTrue)
| set referring physician's name
virtual OFCondition | setStudyDescription (const OFString &value, const OFBool check=OFTrue)
| set study description
virtual OFCondition | setSeriesDescription (const OFString &value, const OFBool check=OFTrue)
| set series description
virtual OFCondition | setProtocolName (const OFString &value, const OFBool check=OFTrue)
| set protocol name
virtual OFCondition | setManufacturer (const OFString &value, const OFBool check=OFTrue)
| set manufacturer
virtual OFCondition | setManufacturerModelName (const OFString &value, const OFBool check=OFTrue)
| set manufacturer's model name
virtual OFCondition | setDeviceSerialNumber (const OFString &value, const OFBool check=OFTrue)
| set device serial number
virtual OFCondition | setSoftwareVersions (const OFString &value, const OFBool check=OFTrue)
| set software version(s)
virtual OFCondition | setSynchronizationFrameOfReferenceUID (const OFString &value, const OFBool check=OFTrue)
| set synchronization frame of reference UID
virtual OFCondition | setSynchronizationTrigger (const OFString &value, const OFBool check=OFTrue)
| set synchronization trigger
virtual OFCondition | setAcquisitionTimeSynchronized (const OFString &value, const OFBool check=OFTrue)
| set acquisition time synchronized
virtual OFCondition | setContentDate (const OFString &value, const OFBool check=OFTrue)
| set content date
virtual OFCondition | setContentTime (const OFString &value, const OFBool check=OFTrue)
| set content time
virtual OFCondition | setStudyDate (const OFString &value, const OFBool check=OFTrue)
| set study date
virtual OFCondition | setStudyTime (const OFString &value, const OFBool check=OFTrue)
| set study time
virtual OFCondition | setSeriesDate (const OFString &value, const OFBool check=OFTrue)
| set series date
virtual OFCondition | setSeriesTime (const OFString &value, const OFBool check=OFTrue)
| set series time
virtual OFCondition | setStudyID (const OFString &value, const OFBool check=OFTrue)
| set study ID
virtual OFCondition | setPatientID (const OFString &value, const OFBool check=OFTrue)
| set patient ID
virtual OFCondition | setIssuerOfPatientID (const OFString &value, const OFBool check=OFTrue)
| set issuer of patient ID
virtual OFCondition | setSeriesNumber (const OFString &value, const OFBool check=OFTrue)
| set series number
virtual OFCondition | setInstanceNumber (const OFString &value, const OFBool check=OFTrue)
| set instance number
virtual OFCondition | setAccessionNumber (const OFString &value, const OFBool check=OFTrue)
| set accession number
virtual void | createNewStudy ()
| create new study.
virtual void | createNewSeries ()
| create a new series.
virtual OFCondition | createNewSeriesInStudy (const OFString &studyUID, const OFBool check=OFTrue)
| create a new series within a given study.
virtual void | createNewSOPInstance ()
| create a new SOP instance.
virtual OFCondition | createNewDocument ()
| create a new document.
virtual OFCondition | createNewDocument (const E_DocumentType documentType)
| create a new document of the specified type.
virtual OFCondition | changeDocumentType (const E_DocumentType documentType)
| change the type of the current document.
virtual OFCondition | createRevisedVersion (const OFBool clearList=OFTrue)
| create a revised version of the current document.
virtual OFCondition | completeDocument ()
| complete the current document.
virtual OFCondition | completeDocument (const OFString &description, const OFBool check=OFTrue)
| complete the current document and set a completion description.
virtual OFCondition | verifyDocument (const OFString &observerName, const OFString &organization, const OFString &dateTime="", const OFBool check=OFTrue)
| verify the current document by a specific observer.
virtual OFCondition | verifyDocument (const OFString &observerName, const DSRCodedEntryValue &observerCode, const OFString &organization, const OFString &dateTime="", const OFBool check=OFTrue)
| verify the current document by a specific observer.
virtual void | removeVerification ()
| remove verification information.
virtual OFCondition | finalizeDocument ()
| finalize the current state of the document.

## Protected Member Functions

OFCondition | readXMLDocumentHeader (DSRXMLDocument &doc, DSRXMLCursor cursor, const size_t flags)
| read XML document header
OFCondition | readXMLPatientData (const DSRXMLDocument &doc, DSRXMLCursor cursor, const size_t flags)
| read XML "patient" data
OFCondition | readXMLStudyData (const DSRXMLDocument &doc, DSRXMLCursor cursor, const size_t flags)
| read XML "study" data
OFCondition | readXMLSeriesData (const DSRXMLDocument &doc, DSRXMLCursor cursor, const size_t flags)
| read XML "series" data
OFCondition | readXMLInstanceData (const DSRXMLDocument &doc, DSRXMLCursor cursor, const size_t flags)
| read XML "instance" data
OFCondition | readXMLDocumentData (const DSRXMLDocument &doc, DSRXMLCursor cursor, const size_t flags)
| read XML "document" data
OFCondition | readXMLVerifyingObserverData (const DSRXMLDocument &doc, DSRXMLCursor cursor, const size_t flags)
| read XML verifying observer data
void | renderHTMLPatientData (STD_NAMESPACE ostream &stream, const size_t flags)
| render patient name, sex, birthdate and ID in HTML/XHTML format
void | renderHTMLReferenceList (STD_NAMESPACE ostream &stream, DSRSOPInstanceReferenceList &refList, const size_t flags, const char *urlPrefix=NULL)
| render list of referenced SOP instances in HTML/XHTML format
void | renderHTMLReferenceList (STD_NAMESPACE ostream &stream, DSRReferencedInstanceList &refList, const size_t flags, const char *urlPrefix=NULL)
| render list of referenced SOP instances in HTML/XHTML format
OFCondition | checkDatasetForReading (DcmItem &dataset, E_DocumentType &documentType)
| check the given dataset before reading.
const char * | getSpecificCharacterSet () const
| get current value of specific character set
void | updateAttributes (const OFBool updateAll=OFTrue, const OFBool verboseMode=OFTrue)
| update various DICOM attributes.
Protected Member Functions inherited from DSRTypes
virtual | ~DSRTypes ()
| destructor.

## Private Attributes

DSRDocumentTree | DocumentTree
| SR document tree.
OFBool | FinalizedFlag
| flag indicating whether this document is finalized or not
E_PreliminaryFlag | PreliminaryFlagEnum
| enumerated value: preliminary, final
E_CompletionFlag | CompletionFlagEnum
| enumerated value: partial, complete
E_VerificationFlag | VerificationFlagEnum
| enumerated value: unverified, verified
E_CharacterSet | SpecificCharacterSetEnum
| defined term: see class DSRTypes
DcmUniqueIdentifier | SOPClassUID
| SOP Class UID: (UI, 1, 1).
DcmUniqueIdentifier | SOPInstanceUID
| SOP Instance UID: (UI, 1, 1).
DcmCodeString | SpecificCharacterSet
| Specific Character Set: (CS, 1-n, 1C).
DcmDate | InstanceCreationDate
| Instance Creation Date: (DA, 1, 3).
DcmTime | InstanceCreationTime
| Instance Creation Time: (TM, 1, 3).
DcmUniqueIdentifier | InstanceCreatorUID
| Instance Creator UID: (UI, 1, 3).
DSRCodingSchemeIdentificationList | CodingSchemeIdentification
| Coding Scheme Identification Sequence: (SQ, 1-n, 3).
DcmShortString | TimezoneOffsetFromUTC
| Context Group Identification Sequence: (SQ, 1-n, 3).
DcmUniqueIdentifier | StudyInstanceUID
| Study Instance UID: (UI, 1, 1).
DcmDate | StudyDate
| Study Date: (DA, 1, 2).
DcmTime | StudyTime
| Study Time: (TM, 1, 2).
DcmPersonName | ReferringPhysicianName
| Referring Physician's Name: (PN, 1, 2).
DcmShortString | StudyID
| Study ID: (SH, 1, 2).
DcmShortString | AccessionNumber
| Accession Number: (SH, 1, 2).
DcmLongString | StudyDescription
| Study Description: (LO, 1, 3).
DcmPersonName | PatientName
| Patient's Name: (PN, 1, 2).
DcmLongString | PatientID
| Patient ID: (LO, 1, 2).
DcmLongString | IssuerOfPatientID
| Issuer of Patient ID: (LO, 1, 3).
DcmDate | PatientBirthDate
| Patient's Birth Date: (DA, 1, 2).
DcmCodeString | PatientSex
| Patient's Sex: (CS, 1, 2).
DcmAgeString | PatientAge
| Patient's Age: (AS, 1, 3).
DcmDecimalString | PatientSize
| Patient's Size: (DS, 1, 3).
DcmDecimalString | PatientWeight
| Patient's Weight: (DS, 1, 3).
DcmLongString | Manufacturer
| Manufacturer: (LO, 1, 2).
DcmLongString | ManufacturerModelName
| Manufacturer's Model Name: (LO, 1, 3).
DcmLongString | DeviceSerialNumber
| Device Serial Number: (LO, 1, 3).
DcmLongString | SoftwareVersions
| Software Version(s): (LO, 1-n, 3).
DcmUniqueIdentifier | SynchronizationFrameOfReferenceUID
| Synchronization Frame of Reference UID: (UI, 1, 1).
DcmCodeString | SynchronizationTrigger
| Synchronization Trigger: (CS, 1, 1).
DcmCodeString | AcquisitionTimeSynchronized
| Acquisition Time Synchronized: (CS, 1, 1).
DcmCodeString | Modality
| Modality: (CS, 1, 1).
DcmUniqueIdentifier | SeriesInstanceUID
| Series Instance Number: (UI, 1, 1).
DcmIntegerString | SeriesNumber
| Series Number: (IS, 1, 1).
DcmDate | SeriesDate
| Series Date: (DA, 1, 3).
DcmTime | SeriesTime
| Series Time: (TM, 1, 3).
DcmLongString | ProtocolName
| Protocol Name: (LO, 1, 3).
DcmLongString | SeriesDescription
| Series Description: (LO, 1, 3).
DcmSequenceOfItems | ReferencedPerformedProcedureStep
| Series Description Code Sequence: (SQ, 1, 3).
DcmIntegerString | InstanceNumber
| Instance Number: (IS, 1, 1).
DcmCodeString | PreliminaryFlag
| Preliminary Flag: (CS, 1, 3).
DcmCodeString | CompletionFlag
| Completion Flag: (CS, 1, 1).
DcmLongString | CompletionFlagDescription
| Completion Flag Description: (LO, 1, 3).
DcmCodeString | VerificationFlag
| Verification Flag: (CS, 1, 1).
DcmDate | ContentDate
| Content Date: (DA, 1, 1).
DcmTime | ContentTime
| Content Time: (TM, 1, 1).
DcmSequenceOfItems | VerifyingObserver
| Verifying Observer Sequence: (SQ, 1-n, 1C).
DSRSOPInstanceReferenceList | PredecessorDocuments
| Author Observer Sequence: (SQ, 1-n, 3).
DSRSOPInstanceReferenceList | IdenticalDocuments
| Identical Documents Sequence: (SQ, 1-n, 1C).
DcmSequenceOfItems | PerformedProcedureCode
| Performed Procedure Code Sequence: (SQ, 1-n, 2).
DSRSOPInstanceReferenceList | CurrentRequestedProcedureEvidence
| Current Requested Procedure Evidence Sequence: (SQ, 1-n, 1C).
DSRSOPInstanceReferenceList | PertinentOtherEvidence
| Pertinent Other Evidence Sequence: (SQ, 1-n, 1C).
DSRReferencedInstanceList | ReferencedInstances
| Referenced Instance Sequence: (SQ, 1-n, 1C).

## Additional Inherited Members

Protected Types inherited from DSRTypes

enum

E_DocumentType {
DT_invalid , DT_unknown = DT_invalid , DT_BasicTextSR , DT_EnhancedSR ,
DT_ComprehensiveSR , DT_KeyObjectSelectionDocument , DT_MammographyCadSR , DT_ChestCadSR ,
DT_ColonCadSR , DT_ProcedureLog , DT_XRayRadiationDoseSR , DT_EnhancedXRayRadiationDoseSR ,
DT_SpectaclePrescriptionReport , DT_MacularGridThicknessAndVolumeReport , DT_ImplantationPlanSRDocument , DT_Comprehensive3DSR ,
DT_RadiopharmaceuticalRadiationDoseSR , DT_ExtensibleSR , DT_AcquisitionContextSR , DT_SimplifiedAdultEchoSR ,
DT_PatientRadiationDoseSR , DT_PerformedImagingAgentAdministrationSR , DT_PlannedImagingAgentAdministrationSR , DT_RenditionSelectionDocument ,
DT_WaveformAnnotationSR , DT_last = DT_WaveformAnnotationSR
}

| SR document types (DICOM IOD). More...
enum | E_RelationshipType { RT_invalid , RT_unknown , RT_isRoot , RT_contains , RT_hasObsContext , RT_hasAcqContext , RT_hasConceptMod , RT_hasProperties , RT_inferredFrom , RT_selectedFrom , RT_last = RT_selectedFrom }
| SR relationship types. More...
enum | E_ValueType { VT_invalid , VT_Text , VT_Code , VT_Num , VT_DateTime , VT_Date , VT_Time , VT_UIDRef , VT_PName , VT_SCoord , VT_SCoord3D , VT_TCoord , VT_Composite , VT_Image , VT_Waveform , VT_Container , VT_byReference , VT_includedTemplate , VT_last = VT_includedTemplate }
| SR value types. More...
enum | E_PresentationStateType { PT_invalid , PT_unknown = PT_invalid , PT_Grayscale , PT_Color , PT_PseudoColor , PT_Blending , PT_XAXRFGrayscale , PT_GrayscalePlanarMPR , PT_CompositingPlanarMPR , PT_AdvancedBlending , PT_VolumeRendering , PT_SegmentedVolumeRendering , PT_MultipleVolumeRendering , PT_VariableModalityLUT , PT_Waveform , PT_WaveformAcquisition , PT_last = PT_WaveformAcquisition }
| Softcopy presentation state types. More...
enum | E_GraphicType { GT_invalid , GT_unknown = GT_invalid , GT_Point , GT_Multipoint , GT_Polyline , GT_Circle , GT_Ellipse , GT_last = GT_Ellipse }
| SR graphic types. More...
enum | E_GraphicType3D { GT3_invalid , GT3_unknown = GT3_invalid , GT3_Point , GT3_Multipoint , GT3_Polyline , GT3_Polygon , GT3_Ellipse , GT3_Ellipsoid , GT3_last = GT3_Ellipsoid }
| SR graphic types (3D). More...
enum | E_TemporalRangeType { TRT_invalid , TRT_unknown = TRT_invalid , TRT_Point , TRT_Multipoint , TRT_Segment , TRT_Multisegment , TRT_Begin , TRT_End , TRT_last = TRT_End }
| SR temporal range types. More...
enum | E_ContinuityOfContent { COC_invalid , COC_Separate , COC_Continuous , COC_last = COC_Continuous }
| SR continuity of content flag. More...
enum | E_PreliminaryFlag { PF_invalid , PF_Preliminary , PF_Final , PF_last = PF_Final }
| SR document preliminary flag. More...
enum | E_CompletionFlag { CF_invalid , CF_Partial , CF_Complete , CF_last = CF_Complete }
| SR document completion flag. More...
enum | E_VerificationFlag { VF_invalid , VF_Unverified , VF_Verified , VF_last = VF_Verified }
| SR document verification flag. More...
enum | E_CharacterSet { CS_invalid , CS_unknown = CS_invalid , CS_ASCII , CS_default = CS_ASCII , CS_Latin1 , CS_Latin2 , CS_Latin3 , CS_Latin4 , CS_Cyrillic , CS_Arabic , CS_Greek , CS_Hebrew , CS_Latin5 , CS_Latin9 , CS_Thai , CS_Japanese , CS_Korean , CS_ChineseISO , CS_ChineseGB18030 , CS_ChineseGBK , CS_UTF8 , CS_last = CS_UTF8 }
| Specific character set. More...
enum | E_CodeValueType { CVT_auto , CVT_Short , CVT_Long , CVT_URN }
| Code value type. More...
enum | E_AddMode { AM_afterCurrent , AM_beforeCurrent , AM_belowCurrent , AM_belowCurrentBeforeFirstChild }
| Add node mode. More...
Static Protected Member Functions inherited from DSRTypes
static const char * | documentTypeToSOPClassUID (const E_DocumentType documentType)
| convert SR document type to SOP class UID
static const char * | documentTypeToModality (const E_DocumentType documentType)
| convert SR document type to modality
static const char * | documentTypeToReadableName (const E_DocumentType documentType)
| convert SR document type to readable name.
static const char * | documentTypeToDocumentTitle (const E_DocumentType documentType, OFString &documentTitle)
| convert SR document type to document title.
static OFBool | requiresEnhancedEquipmentModule (const E_DocumentType documentType)
| check whether a given SR document type requires the Enhanced General Equipment Module
static OFBool | requiresTimezoneModule (const E_DocumentType documentType)
| check whether a given SR document type requires the Timezone Module
static OFBool | requiresSynchronizationModule (const E_DocumentType documentType)
| check whether a given SR document type requires the Synchronization Module
static OFBool | usesSRDocumentSeriesModule (const E_DocumentType documentType)
| check whether a given SR document type uses the SR Document Series Module (instead of the Key Object Document Series Module)
static OFBool | usesKeyObjectDocumentSeriesModule (const E_DocumentType documentType)
| check whether a given SR document type uses the Key Object Document Series Module (instead of the SR Document Series Module)
static OFBool | usesSRDocumentGeneralModule (const E_DocumentType documentType)
| check whether a given SR document type uses the SR Document General Module (instead of the Key Object Document Module)
static OFBool | usesKeyObjectDocumentModule (const E_DocumentType documentType)
| check whether a given SR document type uses the Key Object Document Module (instead of the SR Document General Module)
static const char * | relationshipTypeToDefinedTerm (const E_RelationshipType relationshipType)
| convert relationship type to DICOM defined term
static const char * | relationshipTypeToReadableName (const E_RelationshipType relationshipType)
| convert relationship type to readable name.
static const char * | valueTypeToDefinedTerm (const E_ValueType valueType)
| convert value type to DICOM defined term
static const char * | valueTypeToXMLTagName (const E_ValueType valueType)
| convert value type to XML tag name
static const char * | valueTypeToReadableName (const E_ValueType valueType)
| convert value type to readable name.
static const char * | presentationStateTypeToShortName (const E_PresentationStateType pstateType)
| convert presentation state type to short name.
static const char * | graphicTypeToEnumeratedValue (const E_GraphicType graphicType)
| convert graphic type to DICOM enumerated value
static const char * | graphicTypeToReadableName (const E_GraphicType graphicType)
| convert graphic type to readable name.
static const char * | graphicType3DToEnumeratedValue (const E_GraphicType3D graphicType)
| convert graphic type (3D) to DICOM enumerated value
static const char * | graphicType3DToReadableName (const E_GraphicType3D graphicType)
| convert graphic type (3D) to readable name.
static const char * | temporalRangeTypeToEnumeratedValue (const E_TemporalRangeType temporalRangeType)
| convert temporal range type to DICOM enumerated value
static const char * | temporalRangeTypeToReadableName (const E_TemporalRangeType temporalRangeType)
| convert temporal range type to readable name.
static const char * | continuityOfContentToEnumeratedValue (const E_ContinuityOfContent continuityOfContent)
| convert continuity of content flag to DICOM enumerated value
static const char * | preliminaryFlagToEnumeratedValue (const E_PreliminaryFlag preliminaryFlag)
| convert preliminary flag to DICOM enumerated value
static const char * | completionFlagToEnumeratedValue (const E_CompletionFlag completionFlag)
| convert completion flag to DICOM enumerated value
static const char * | verificationFlagToEnumeratedValue (const E_VerificationFlag verificationFlag)
| convert verification flag to DICOM enumerated value
static const char * | characterSetToDefinedTerm (const E_CharacterSet characterSet)
| convert character set to DICOM defined term
static const char * | characterSetToHTMLName (const E_CharacterSet characterSet)
| convert character set to HTML name.
static const char * | characterSetToXMLName (const E_CharacterSet characterSet)
| convert character set to XML name.
static E_DocumentType | sopClassUIDToDocumentType (const OFString &sopClassUID)
| convert SOP class UID to SR document type
static E_RelationshipType | definedTermToRelationshipType (const OFString &definedTerm)
| convert DICOM defined term to relationship type
static E_ValueType | definedTermToValueType (const OFString &definedTerm)
| convert DICOM defined term to value type
static E_PresentationStateType | sopClassUIDToPresentationStateType (const OFString &sopClassUID)
| convert SOP class UID to presentation state type
static E_ValueType | xmlTagNameToValueType (const OFString &xmlTagName)
| convert XML tag name to value type
static E_GraphicType | enumeratedValueToGraphicType (const OFString &enumeratedValue)
| convert DICOM enumerated value to graphic type
static E_GraphicType3D | enumeratedValueToGraphicType3D (const OFString &enumeratedValue)
| convert DICOM enumerated value to graphic type (3D)
static E_TemporalRangeType | enumeratedValueToTemporalRangeType (const OFString &enumeratedValue)
| convert DICOM enumerated value to temporal range type
static E_ContinuityOfContent | enumeratedValueToContinuityOfContent (const OFString &enumeratedValue)
| convert DICOM enumerated value to continuity of content flag
static E_PreliminaryFlag | enumeratedValueToPreliminaryFlag (const OFString &enumeratedValue)
| convert DICOM enumerated value to preliminary flag
static E_CompletionFlag | enumeratedValueToCompletionFlag (const OFString &enumeratedValue)
| convert DICOM enumerated value to completion flag
static E_VerificationFlag | enumeratedValueToVerificationFlag (const OFString &enumeratedValue)
| convert DICOM enumerated value to verification flag
static E_CharacterSet | definedTermToCharacterSet (const OFString &definedTerm)
| convert DICOM defined term to character set.
static OFBool | isDocumentTypeSupported (const E_DocumentType documentType)
| check whether specified SR document type is supported by this library
static const OFString & | currentDate (OFString &dateString)
| get current date in DICOM 'DA' format.
static const OFString & | currentTime (OFString &timeString)
| get current time in DICOM 'TM' format.
static const OFString & | currentDateTime (OFString &dateTimeString)
| get current date and time in DICOM 'DT' format.
static const OFString & | localTimezone (OFString &timezoneString)
| get local timezone in DICOM format.
static const OFString & | dicomToReadableDate (const OFString &dicomDate, OFString &readableDate)
| convert DICOM date string to readable format.
static const OFString & | dicomToReadableTime (const OFString &dicomTime, OFString &readableTime)
| convert DICOM time string to readable format.
static const OFString & | dicomToReadableDateTime (const OFString &dicomDateTime, OFString &readableDateTime)
| convert DICOM date time string to readable format.
static const OFString & | dicomToReadablePersonName (const OFString &dicomPersonName, OFString &readablePersonName)
| convert DICOM person name to readable format.
static const OFString & | dicomToXMLPersonName (const OFString &dicomPersonName, OFString &xmlPersonName, const OFBool writeEmptyValue=OFFalse)
| convert DICOM person name to XML format.
static const char * | numberToString (const size_t number, char *stringValue, size_t stringLength)
| convert unsigned integer number to character string
static size_t | stringToNumber (const char *stringValue)
| convert string to unsigned integer number
static const OFString & | convertToPrintString (const OFString &sourceString, OFString &printString)
| convert character string to print string.
static const OFString & | convertToHTMLString (const OFString &sourceString, OFString &markupString, const size_t flags=0, const OFBool newlineAllowed=OFFalse)
| convert character string to HTML mnenonic string.
static const OFString & | convertToXMLString (const OFString &sourceString, OFString &markupString)
| convert character string to XML mnenonic string.
static OFBool | checkForValidReference (const OFString &stringValue)
| check string for valid reference (as used for by-reference relationships).
static DSRIODConstraintChecker * | createIODConstraintChecker (const E_DocumentType documentType)
| create specified SR IOD content relationship constraint checker object.
static DSRDocumentTreeNode * | createDocumentTreeNode (const E_RelationshipType relationshipType, const E_ValueType valueType)
| create specified document tree node.
static OFCondition | addElementToDataset (OFCondition &result, DcmItem &dataset, DcmElement *delem, const OFString &vm, const OFString &type, const char *moduleName=NULL)
| add given element to the dataset.
static void | removeAttributeFromSequence (DcmSequenceOfItems &sequence, const DcmTagKey &tagKey)
| remove given attribute from the sequence.
static OFCondition | getElementFromDataset (DcmItem &dataset, DcmElement &delem)
| get element from dataset
static const char * | getStringValueFromElement (const DcmElement &delem)
| get string value from element
static const OFString & | getStringValueFromElement (const DcmElement &delem, OFString &stringValue)
| get string value from element.
static OFCondition | getStringValueFromElement (const DcmElement &delem, OFString &stringValue, const signed long pos)
| get string value from element
static const OFString & | getPrintStringFromElement (const DcmElement &delem, OFString &stringValue)
| get string value from element and convert to "print" format.
static const OFString & | getMarkupStringFromElement (const DcmElement &delem, OFString &stringValue, const OFBool convertNonASCII=OFFalse)
| get string value from element and convert to HTML/XML.
static OFCondition | getStringValueFromDataset (DcmItem &dataset, const DcmTagKey &tagKey, OFString &stringValue, const signed long pos=0)
| get string value from dataset
static OFCondition | putStringValueToDataset (DcmItem &dataset, const DcmTag &tag, const OFString &stringValue, const OFBool allowEmpty=OFTrue)
| put string value to dataset
static OFBool | checkElementValue (DcmElement *delem, const DcmTagKey &tagKey, const OFString &vm, const OFString &type, const OFCondition &searchCond=EC_Normal, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| check element value for correct value multiplicity and type.
static OFBool | checkElementValue (DcmElement &delem, const OFString &vm, const OFString &type, const OFCondition &searchCond=EC_Normal, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| check element value for correct value multiplicity and type.
static OFCondition | getAndCheckElementFromDataset (DcmItem &dataset, DcmElement &delem, const OFString &vm, const OFString &type, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| get element from dataset and check it for correct value multiplicity and type.
static OFCondition | getAndCheckStringValueFromDataset (DcmItem &dataset, const DcmTagKey &tagKey, OFString &stringValue, const OFString &vm, const OFString &type, const char *moduleName=NULL, const OFBool acceptViolation=OFFalse)
| get string value from dataset and check it for correct value multiplicity and type.
static void | printInvalidContentItemMessage (const char *action, const DSRDocumentTreeNode *node, const char *location=NULL)
| print the warning message that the current content item is invalid/incomplete.
static void | printContentItemErrorMessage (const char *action, const OFCondition &result, const DSRDocumentTreeNode *node, const char *location=NULL)
| print an error message for the current content item.
static void | printUnknownValueWarningMessage (const char *valueName, const char *readValue=NULL, const char *action="Reading")
| print a warning message that an unknown/unsupported value has been determined
static OFBool | writeStringValueToXML (STD_NAMESPACE ostream &stream, const OFString &stringValue, const OFString &tagName, const OFBool writeEmptyValue=OFFalse)
| write string value to XML output stream.
static OFBool | writeStringFromElementToXML (STD_NAMESPACE ostream &stream, DcmElement &delem, const OFString &tagName, const OFBool writeEmptyValue=OFFalse)
| write string value from DICOM element to XML output stream.
static size_t | createHTMLAnnexEntry (STD_NAMESPACE ostream &docStream, STD_NAMESPACE ostream &annexStream, const OFString &referenceText, size_t &annexNumber, const size_t flags=0)
| create an HTML annex entry with hyperlinks.
static size_t | createHTMLFootnote (STD_NAMESPACE ostream &docStream, STD_NAMESPACE ostream &footnoteStream, size_t &footnoteNumber, const size_t nodeID, const size_t flags=0)
| create an HTML footnote with hyperlinks
static OFCondition | appendStream (STD_NAMESPACE ostream &mainStream, OFOStringStream &tempStream, const char *heading=NULL)
| append one output stream to another.
Static Protected Attributes inherited from DSRTypes
static const size_t | RF_readDigitalSignatures
| read digital signatures from dataset
static const size_t | RF_acceptUnknownRelationshipType
| accept unknown/missing relationship type
static const size_t | RF_acceptInvalidContentItemValue
| accept invalid content item value (e.g. violation of VR or VM definition)
static const size_t | RF_ignoreRelationshipConstraints
| ignore relationship constraints for this document class
static const size_t | RF_ignoreContentItemErrors
| do not abort on content item errors (e.g. missing value type specific attributes)
static const size_t | RF_skipInvalidContentItems
| do not abort when detecting an invalid content item, skip invalid sub-tree instead
static const size_t | RF_showCurrentlyProcessedItem
| show the currently processed content item (e.g. "1.2.3")
static const size_t | HF_neverExpandChildrenInline
| external: never expand child nodes inline
static const size_t | HF_alwaysExpandChildrenInline
| external: always expand child nodes inline
static const size_t | HF_renderInlineCodes
| external: render codes even if they appear inline
static const size_t | HF_useCodeDetailsTooltip
| external: render code details as a tooltip (not with HTML 3.2)
static const size_t | HF_renderConceptNameCodes
| external: render concept name codes (default: code meaning only)
static const size_t | HF_renderNumericUnitCodes
| external: render the code of the numeric measurement unit
static const size_t | HF_useCodeMeaningAsUnit
| external: use code meaning for the numeric measurement unit (default: code value)
static const size_t | HF_renderPatientTitle
| external: use patient information as document title (default: document type)
static const size_t | HF_renderNoDocumentHeader
| external: render no general document information (header)
static const size_t | HF_renderDcmtkFootnote
| external: render dcmtk/dcmsr comment at the end of the document
static const size_t | HF_renderFullData
| external: render the full data of all content items
static const size_t | HF_renderSectionTitlesInline
| external: render section titles inline (default: separate paragraph)
static const size_t | HF_copyStyleSheetContent
| external: copy Cascading Style Sheet (CSS) content to HTML file
static const size_t | HF_HTML32Compatibility
| external: output compatible to HTML version 3.2 (default: 4.01)
static const size_t | HF_XHTML11Compatibility
| external: output compatible to XHTML version 1.1 (default: HTML 4.01)
static const size_t | HF_addDocumentTypeReference
| external: add explicit reference to HTML document type (DTD)
static const size_t | HF_omitGeneratorMetaElement
| external: omit generator meta element referring to the DCMTK
static const size_t | HF_renderItemsSeparately
| internal: render items separately (for container with SEPARATE flag)
static const size_t | HF_renderItemInline
| internal: expand items inline when they are short and have no child nodes
static const size_t | HF_currentlyInsideAnnex
| internal: content item is rendered fully inside the annex
static const size_t | HF_createFootnoteReferences
| internal: create footnote references
static const size_t | HF_convertNonASCIICharacters
| internal: convert non-ASCII characters (> #127) to &#nnn;
static const size_t | HF_renderAllCodes
| shortcut: render all codes
static const size_t | HF_internalUseOnly
| shortcut: filter all flags that are only used internally
static const size_t | XF_writeEmptyTags
| write: write all tags even if their value is empty
static const size_t | XF_writeTemplateIdentification
| write: write template identification information (TID and mapping resource)
static const size_t | XF_alwaysWriteItemIdentifier
| write: always write item identifier "id", not only when item is referenced
static const size_t | XF_codeComponentsAsAttribute
| write: encode code value, coding scheme designator and coding scheme version as attribute instead of element text
static const size_t | XF_relationshipTypeAsAttribute
| write: encode relationship type as attribute instead of element text
static const size_t | XF_valueTypeAsAttribute
| write: encode value type as attribute instead of element text
static const size_t | XF_templateIdentifierAsAttribute
| write: encode template identifier as attribute instead of element text
static const size_t | XF_useDcmsrNamespace
| write: add DCMSR namespace declaration to the XML output
static const size_t | XF_addSchemaReference
| write: add Schema reference to XML document
static const size_t | XF_validateSchema
| read: validate content of XML document against Schema
static const size_t | XF_templateElementEnclosesItems
| read/write: template identification element encloses content items
static const size_t | XF_addCommentsForIncludedTemplate
| write: add comments with details at beginning/end of included template (might be useful for debugging purposes)
static const size_t | XF_acceptEmptyStudySeriesInstanceUID
| read: accept empty Study/Series/SOP Instance UID attribute values (must be filled later)
static const size_t | XF_encodeEverythingAsAttribute
| shortcut: combines all XF_xxxAsAttribute write flags (see above)
static const size_t | PF_printItemPosition
| print item position ("1.2.3") instead of line indentation
static const size_t | PF_shortenLongItemValues
| shorten long item value (e.g. long texts)
static const size_t | PF_printSOPInstanceUID
| print SOP instance UID of referenced objects
static const size_t | PF_printConceptNameCodes
| print coding scheme designator/version and code value of concept names
static const size_t | PF_printNoDocumentHeader
| print no general document information (header)
static const size_t | PF_printTemplateIdentification
| print template identification (TID and mapping resource)
static const size_t | PF_useANSIEscapeCodes
| use ANSI escape codes for output
static const size_t | PF_printLongSOPClassName
| print long SOP class name of referenced objects (default: short name for images)
static const size_t | PF_printSOPClassUID
| print SOP class UID of referenced objects (instead of the name)
static const size_t | PF_printInvalidCodes
| print code triple for invalid codes (instead of the text "invalid code")
static const size_t | PF_printNodeID
| print node ID at the beginning of each line (might be useful for debugging purposes)
static const size_t | PF_indicateEnhancedEncodingMode
| indicate with a "*" that the "enhanced encoding mode" is used for codes
static const size_t | PF_printAnnotation
| print annotation of a content item (optional, e.g. user-defined information)
static const size_t | PF_hideIncludedTemplateNodes
| do not print internal "included template" nodes (position counter is still increased)
static const size_t | PF_dontCountIncludedTemplateNodes
| do not count internal "included template" nodes (only with PF_hideIncludedTemplateNodes)
static const size_t | PF_printEmptyCodes
| print text "empty code" for empty codes (instead of "invalid code")
static const size_t | PF_printAllCodes
| shortcut: print all codes (combines all PF_printXxxCodes flags, see above)
static const size_t | CM_updatePositionString
| update the position string using the node ID
static const size_t | CM_updateNodeID
| update the node ID using the position string
static const size_t | CM_resetReferenceTargetFlag
| reset the reference target flag for all nodes
static const size_t | CB_maskPrintFlags
| bit mask (filter) for valid print flags (see PF_xxx)
static const size_t | CB_maskReadFlags
| bit mask (filter) for valid read flags (see RF_xxx)

## Detailed Description

Interface class for 'dcmsr' (DICOM Structured Reporting Documents).

This class supports reading, writing, creation, printing and rendering of DICOM Structured Reporting (SR) documents. The list of supported SOP classes is available in file "dsrtypes.h". Also see DSRTypes::E_DocumentType.

## Constructor & Destructor Documentation

## DSRDocument()

DSRDocument::DSRDocument | ( | const E_DocumentType | documentType = DT_BasicTextSR | ) |

(default) constructor.

The parameter 'documentType' is optional and has a default value.

Parameters

  documentType | type of the SR document (see DSRTypes::E_DocumentType)

References DSRTypes::DT_BasicTextSR.

## Member Function Documentation

## changeDocumentType()

virtual OFCondition DSRDocument::changeDocumentType | ( | const E_DocumentType | documentType | ) |

virtual

change the type of the current document.

Please note that only the type of the SR document is changed (if possible) but no new SOP instance is created. If needed, this has to be done with createNewSOPInstance() in addition to this method or by calling createNewDocument() instead of this method. Before changing the document type, it is checked whether the currently stored document tree complies with the relationship content constraints of the new SR IOD.

Parameters

  documentType | new type of the SR document (see DSRTypes::E_DocumentType)

Returns
  status, EC_Normal if successful, an error code otherwise

## checkDatasetForReading()

OFCondition DSRDocument::checkDatasetForReading | ( | DcmItem & | dataset,
|  | E_DocumentType & | documentType )

protected

check the given dataset before reading.

This methods checks whether the dataset contains at least the DICOM attributes SOP class UID and modality. Any incorrectness regarding these two attributes is reported to the logger. Currently unsupported SOP classes are also reported as an error.

Parameters

  dataset | DICOM dataset to be checked
  documentType | SR document type retrieved from the SOP class UID

Returns
  status, EC_Normal if successful, an error code otherwise

## completeDocument() [1/2]

virtual OFCondition DSRDocument::completeDocument | ( |  | ) |

virtual

complete the current document.

Sets the completion flag to COMPLETE if not already done (fails otherwise). This flag describes the estimated degree of completeness of an SR Document (see DICOM standard for details). The completion flag description is set to an empty string (i.e. absent in DICOM dataset).

Note
  Not applicable to document types that use the Key Object Document Module.

Returns
  status, EC_Normal if successful, an error code otherwise

## completeDocument() [2/2]

virtual OFCondition DSRDocument::completeDocument | ( | const OFString & | description,
|  | const OFBool | check = OFTrue )

virtual

complete the current document and set a completion description.

Sets the completion flag to COMPLETE if not already done (fails otherwise). This flag describes the estimated degree of completeness of an SR Document (see DICOM standard for details). The completion flag description can be modified independently from the flag by means of the method setCompletionFlagDescription() - see above.

Note
  Not applicable to document types that use the Key Object Document Module.

Parameters

  description | explanation of the value set for completion flag. (optional, see previous method, VR=LO)
  check | check 'description' for conformance with VR and VM if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## createNewDocument() [1/2]

virtual OFCondition DSRDocument::createNewDocument | ( |  | ) |

virtual

create a new document.

A new SOP instance is only created if the current document type was valid/supported. Please note that the current document is deleted (cleared) by this method.

Returns
  status, EC_Normal if successful, an error code otherwise

## createNewDocument() [2/2]

virtual OFCondition DSRDocument::createNewDocument | ( | const E_DocumentType | documentType | ) |

virtual

create a new document of the specified type.

A new SOP instance is only created if the current document type was valid/supported. Please note that the current document is deleted (cleared) by this method.

Parameters

  documentType | type of the new SR document (see DSRTypes::E_DocumentType)

Returns
  status, EC_Normal if successful, an error code otherwise

## createNewSeries()

virtual void DSRDocument::createNewSeries | ( |  | ) |

virtual

create a new series.

After generating a new series instance UID the method createNewSOPInstance() is called, i.e. also a new SOP instance UID is generated. This is a requirement of the DICOM standard. All other series-related attributes are cleared.

## createNewSeriesInStudy()

virtual OFCondition DSRDocument::createNewSeriesInStudy | ( | const OFString & | studyUID,
|  | const OFBool | check = OFTrue )

virtual

create a new series within a given study.

After generating a new series instance UID within the given study the method createNewSOPInstance() is called, i.e. also a SOP instance UID is generated. This is a requirement of the DICOM standard. NB: There is no mechanism that makes sure that the study-related attributes are consistent for all series of a study. This either has to be done manually or readStudyData() should be used in combination with createNewSeries().

Parameters

  studyUID | study instance UID to be set (should be a valid UID)
  check | check 'studyUID' for conformance with VR and VM if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## createNewSOPInstance()

virtual void DSRDocument::createNewSOPInstance | ( |  | ) |

virtual

create a new SOP instance.

Generate a new SOP instance UID, set the instance creation date/time and reset the finalized flag (OFFalse). This method is used internally for createNewDocument(), createRevisedVersion() and during object initialization. It could also be used explicitly from the calling application if a new UID should be created (this is the case if the study instance UID or series instance UID has changed as well as any other attribute within the SR Document General Module or SR Document Content Module, see DICOM standard for details). This method also updates other DICOM header attributes (by calling updateAttributes()). However, instance-level attributes other than the SOP instance UID are usually not changed (if already set), e.g. the current instance number or content date/time.

## createNewStudy()

virtual void DSRDocument::createNewStudy | ( |  | ) |

virtual

create new study.

After generating a new study instance UID the method createNewSeries() is called, i.e. also a new series instance UID and SOP instance UID are generated. This is a requirement of the DICOM standard. All other study-related attributes are cleared (including the attributes from the Patient Study Module).

## createRevisedVersion()

virtual OFCondition DSRDocument::createRevisedVersion | ( | const OFBool | clearList = OFTrue | ) |

virtual

create a revised version of the current document.

A revised version can only be created if the current document is already completed (see completion flag). If so, a reference to the current document is added to the predecessor documents sequence. If all revised versions of a SR document are stored (written to datasets/files) it is possible to trace back the full chain of previous versions. A new SOP instance is created and the content date/time are set automatically. Furthermore, the verifying observer and identical documents sequence are deleted, the verification flag is set to UNVERIFIED, the completion flag is set to PARTIAL (i.e. not complete), the completion flag description is deleted, all digital signatures contained in the document tree are deleted and the finalized flag is reset (OFFalse). The preliminary flag is not modified by this method. Also the various lists of referenced instances remain unchanged, i.e. they have to be adapted manually if needed.

Note
  Not applicable to document types that use the Key Object Document Module.

Parameters

  clearList | clear list of predecessor documents before adding the current document if OFTrue. Append current document to existing list otherwise.

Returns
  status, EC_Normal if successful, an error code otherwise

## finalizeDocument()

virtual OFCondition DSRDocument::finalizeDocument | ( |  | ) |

virtual

finalize the current state of the document.

A new document is originally not finalized but can be finalized using this method. This internal flag is e.g. used to indicate whether the entire document is digitally signed and, therefore, each newly added verifying observer would corrupt all previous signatures. NB: A document needs to be completed first in order to be finalized. Some of the above document management functions do reset the flag (i.e. set the FinalizedFlag to OFFalse), other methods (e.g. setXXX) do not change the flag though the state of the document is not finalized any more after they have been called.

Note
  Not applicable to document types that use the Key Object Document Module since there is no completion flag attribute in this module. Please note that this method has nothing to do with the preliminary flag.

Returns
  status, EC_Normal if successful, an error code otherwise

## getAccessionNumber()

virtual OFCondition DSRDocument::getAccessionNumber | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get accession number

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getAcquisitionTimeSynchronized()

virtual OFCondition DSRDocument::getAcquisitionTimeSynchronized | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get acquisition time synchronized

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getCodingSchemeIdentification()

virtual DSRCodingSchemeIdentificationList & DSRDocument::getCodingSchemeIdentification | ( |  | ) |

virtual

get list of coding schemes used (Coding Scheme Identification).

The Coding Scheme Identification Sequence maps Coding Scheme Designators to an external coding system registration, or to a private or local coding scheme. See DICOM standard for details.

Returns
  reference to list object

## getCompletionFlag()

virtual E_CompletionFlag DSRDocument::getCompletionFlag | ( |  | ) | const

virtual

get document completion flag.

According to the DICOM standard, this flag describes the estimated degree of completeness of an SR Document. See DICOM standard for details.

Note
  Not applicable to document types that use the Key Object Document Module.

Returns
  completion flag (might be DSRTypes::CF_invalid if read from dataset)

## getCompletionFlagDescription()

virtual OFCondition DSRDocument::getCompletionFlagDescription | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get completion flag description.

Note
  Not applicable to document types that use the Key Object Document Module.

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getContentDate()

virtual OFCondition DSRDocument::getContentDate | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get content date

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getContentTime()

virtual OFCondition DSRDocument::getContentTime | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get content time

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getCurrentRequestedProcedureEvidence()

virtual DSRSOPInstanceReferenceList & DSRDocument::getCurrentRequestedProcedureEvidence | ( |  | ) |

virtual

get list of referenced SOP instances (Current Requested Procedure Evidence).

The DICOM standard states: "The intent of the Current Requested Procedure Evidence Sequence is to reference all evidence created in order to satisfy the current Requested Procedure(s) for this SR Document. This shall include, but is not limited to, all current evidence referenced in the content tree." and "For a completed SR Document satisfying (i.e., being the final report for) the current Requested Procedure(s), this sequence shall list the full set of Composite SOP Instances created for the current Requested Procedure(s). For other SOP Instances that include the SR Document General Module, this sequence shall contain at minimum the set of Composite SOP Instances from the current Requested Procedure(s) that are referenced in the content tree." and "In the context of the Key Object Selection, the current evidence is considered to be only the set of instances referenced within the Key Object Selection."

Returns
  reference to list object

## getDeviceSerialNumber()

virtual OFCondition DSRDocument::getDeviceSerialNumber | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get device serial number

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getDocumentType()

virtual E_DocumentType DSRDocument::getDocumentType | ( |  | ) | const

virtual

get the current SR document type

Returns
  document type (might be DSRTypes::DT_invalid if read from dataset)

## getIdenticalDocuments()

virtual DSRSOPInstanceReferenceList & DSRDocument::getIdenticalDocuments | ( |  | ) |

virtual

get list of identical documents.

Please note that currently the user is responsible for filling and modifying the content of this list. However, the list is automatically cleared when a new instance is created (incl. a revised version of the current document). Possibly, there will be a createDuplicate() method or the like in the future which creates an identical copy of the current document in a new study/series. The DICOM standard states: "If identical copies of an SR Document are to be included in multiple Studies then the entire SR Document shall be duplicated with appropriate changes for inclusion into the different Studies (i.e. Study Instance UID, Series Instance UID, SOP Instance UID, Identical Documents Sequence etc.). The Identical Documents Sequence Attribute in each SOP Instance shall contain references to all other duplicate SOP Instances."

Returns
  reference to list object

## getInstanceCreationDate()

virtual OFCondition DSRDocument::getInstanceCreationDate | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get instance creation date

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getInstanceCreationTime()

virtual OFCondition DSRDocument::getInstanceCreationTime | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get instance creation time

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getInstanceCreatorUID()

virtual OFCondition DSRDocument::getInstanceCreatorUID | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get instance creator UID

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getInstanceNumber()

virtual OFCondition DSRDocument::getInstanceNumber | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get instance number

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getIssuerOfPatientID()

virtual OFCondition DSRDocument::getIssuerOfPatientID | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get issuer of patient ID

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getManufacturer()

virtual OFCondition DSRDocument::getManufacturer | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get manufacturer

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getManufacturerModelName()

virtual OFCondition DSRDocument::getManufacturerModelName | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get manufacturer's model name

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getModality()

virtual OFCondition DSRDocument::getModality | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get modality

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getNumberOfVerifyingObservers()

virtual size_t DSRDocument::getNumberOfVerifyingObservers | ( |  | ) | const

virtual

get number of verifying observers.

A document can be verified more than once. The verification flag should be VERIFIED if any verifying observer is specified. The details on the observer can be retrieved using the getVerifyingObserver() methods.

Note
  Not applicable to document types that use the Key Object Document Module.

Returns
  number of verifying observers (if any), 0 otherwise

## getPatientAge()

virtual OFCondition DSRDocument::getPatientAge | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get patient's age

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getPatientBirthDate()

virtual OFCondition DSRDocument::getPatientBirthDate | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get patient's birth date

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getPatientID()

virtual OFCondition DSRDocument::getPatientID | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get patient ID

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getPatientName()

virtual OFCondition DSRDocument::getPatientName | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get patient's name

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getPatientSex()

virtual OFCondition DSRDocument::getPatientSex | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get patient's sex

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getPatientSize()

virtual OFCondition DSRDocument::getPatientSize | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get patient's size

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getPatientWeight()

virtual OFCondition DSRDocument::getPatientWeight | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get patient's weight

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getPertinentOtherEvidence()

virtual DSRSOPInstanceReferenceList & DSRDocument::getPertinentOtherEvidence | ( |  | ) |

virtual

get list of referenced SOP instances (Pertinent Other Evidence).

The DICOM standard states: "The Pertinent Other Evidence Sequence attribute is used to reference all other evidence considered pertinent for this SR Document that is not listed in the Current Requested Procedure Evidence Sequence. This requires that the same SOP Instance shall not be referenced in both of these Sequences."

Note
  Not applicable to document types that use the Key Object Document Module.

Returns
  reference to list object

## getPredecessorDocuments()

virtual DSRSOPInstanceReferenceList & DSRDocument::getPredecessorDocuments | ( |  | ) |

virtual

get list of predecessor documents.

A document can have more than one (direct) predecessor document. This is e.g. the case when two or more documents have been merged to create it. The corresponding method createRevisedVersion() automatically adds a reference to the current document. The DICOM standard states: "[The Predecessor Documents Sequence] Shall refer to SR SOP Instances (e.g. prior or provisional reports) whose content has been wholly or partially included in this document with or without modification." and "[...] the use of the Predecessor Document Sequence allows tracing back to the input SR Document, which in this case is the previous version."

Note
  Not applicable to document types that use the Key Object Document Module.

Returns
  reference to list object

## getPreliminaryFlag()

virtual E_PreliminaryFlag DSRDocument::getPreliminaryFlag | ( |  | ) | const

virtual

get document preliminary flag.

Note
  Not applicable to document types that use the Key Object Document Module.

Returns
  preliminary flag (might be DSRTypes::PF_invalid if not specified)

## getProtocolName()

virtual OFCondition DSRDocument::getProtocolName | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get protocol name

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getReferencedInstances()

virtual DSRReferencedInstanceList & DSRDocument::getReferencedInstances | ( |  | ) |

virtual

get list of referenced SOP instances significantly related to the current SOP instance.

However, the same instances shall not be referenced in the Current Requested Procedure Evidence Sequence, Pertinent Other Evidence Sequence, Predecessor Documents Sequence or Identical Documents Sequence. The DICOM standard states: "Such referenced Instances may include equivalent documents or renderings of this document. [...] Required if the identity of a CDA Document equivalent to the current SOP Instance is known at the time of creation of this SOP instance. May be present otherwise." The Purpose of Reference Code should be taken from Defined Context Group 7006 (SR Document Purposes of Reference). Note: An equivalent rendering of the document might be provided as an "Encapsulated PDF" DICOM object.

Note
  Not applicable to document types that use the Key Object Document Module.

Returns
  reference to list object

## getReferringPhysicianName()

virtual OFCondition DSRDocument::getReferringPhysicianName | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get referring physician's name

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getSeriesDate()

virtual OFCondition DSRDocument::getSeriesDate | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get series date

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getSeriesDescription()

virtual OFCondition DSRDocument::getSeriesDescription | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get series description

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getSeriesInstanceUID()

virtual OFCondition DSRDocument::getSeriesInstanceUID | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get series instance UID

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getSeriesNumber()

virtual OFCondition DSRDocument::getSeriesNumber | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get series number

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getSeriesTime()

virtual OFCondition DSRDocument::getSeriesTime | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get series time

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getSoftwareVersions()

virtual OFCondition DSRDocument::getSoftwareVersions | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get software version(s)

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getSOPClassUID()

virtual OFCondition DSRDocument::getSOPClassUID | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get SOP class UID

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getSOPInstanceUID()

virtual OFCondition DSRDocument::getSOPInstanceUID | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get SOP instance UID

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getSpecificCharacterSet() [1/2]

const char * DSRDocument::getSpecificCharacterSet | ( |  | ) | const

protected

get current value of specific character set

Returns
  pointer to character string (never NULL)

## getSpecificCharacterSet() [2/2]

virtual OFCondition DSRDocument::getSpecificCharacterSet | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get specific character set

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getSpecificCharacterSetType()

virtual E_CharacterSet DSRDocument::getSpecificCharacterSetType | ( |  | ) | const

virtual

get specific character set type.

If the type is unknown, the original DICOM defined term can be retrieved with the method getSpecificCharacterSet().

Returns
  character set type (might be DSRTypes::CS_invalid or DSRTypes::CS_unknown)

## getStudyDate()

virtual OFCondition DSRDocument::getStudyDate | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get study date

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getStudyDescription()

virtual OFCondition DSRDocument::getStudyDescription | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get study description

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getStudyID()

virtual OFCondition DSRDocument::getStudyID | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get study ID

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getStudyInstanceUID()

virtual OFCondition DSRDocument::getStudyInstanceUID | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get study instance UID

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getStudyTime()

virtual OFCondition DSRDocument::getStudyTime | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get study time

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getSynchronizationFrameOfReferenceUID()

virtual OFCondition DSRDocument::getSynchronizationFrameOfReferenceUID | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get synchronization frame of reference UID

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getSynchronizationTrigger()

virtual OFCondition DSRDocument::getSynchronizationTrigger | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get synchronization trigger

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getTimezoneOffsetFromUTC()

virtual OFCondition DSRDocument::getTimezoneOffsetFromUTC | ( | OFString & | value,
|  | const signed long | pos = 0 ) const

virtual

get timezone offset from UTC

Parameters

  value | reference to variable in which the value should be stored
  pos | index of the value to get (0..vm-1), -1 for all components

Returns
  status, EC_Normal if successful, an error code otherwise

## getTree()

DSRDocumentTree & DSRDocument::getTree | ( |  | ) |

inline

get document tree

Returns
  reference to the document tree

References DocumentTree.

## getVerificationFlag()

virtual E_VerificationFlag DSRDocument::getVerificationFlag | ( |  | ) | const

virtual

get document verification flag.

Note
  Not applicable to document types that use the Key Object Document Module.

Returns
  verification flag (might be DSRTypes::VF_invalid if read from dataset)

## getVerifyingObserver() [1/2]

virtual OFCondition DSRDocument::getVerifyingObserver | ( | const size_t | idx,
|  | OFString & | dateTime,
|  | OFString & | observerName,
|  | DSRCodedEntryValue & | observerCode,
|  | OFString & | organization )

virtual

get information about a verifying observer.

All reference variables are cleared before the information is retrieved, i.e. if an error occurs (return value != EC_Normal) non-empty variables do contain valid (empty) data.

Note
  Not applicable to document types that use the Key Object Document Module.

Parameters

  idx | index of the verifying observer to be retrieved (starting with 1). Use getNumberOfVerifyingObservers() to get the maximum value.
  dateTime | reference to variable where the date and time when this document has been verified should be stored (required)
  observerName | reference to variable where the name of the person who has verified this document should be stored (required)
  observerCode | reference to variable where the observer code should be stored. code identifying the verifying observer (optional, see previous method)
  organization | reference to variable where the name of the organization to which the observer belongs should be stored (required)

Returns
  status, EC_Normal if successful, an error code otherwise

## getVerifyingObserver() [2/2]

virtual OFCondition DSRDocument::getVerifyingObserver | ( | const size_t | idx,
|  | OFString & | dateTime,
|  | OFString & | observerName,
|  | OFString & | organization )

virtual

get information about a verifying observer.

All reference variables are cleared before the information is retrieved, i.e. if an error occurs (return value != EC_Normal) non-empty variables do contain valid (empty) data.

Note
  Not applicable to document types that use the Key Object Document Module.

Parameters

  idx | index of the verifying observer to be retrieved (starting with 1). Use getNumberOfVerifyingObservers() to get the maximum value.
  dateTime | reference to variable where the date and time when this document has been verified should be stored (required)
  observerName | reference to variable where the name of the person who has verified this document should be stored (required)
  organization | reference to variable where the name of the organization to which the observer belongs should be stored (required)

Returns
  status, EC_Normal if successful, an error code otherwise

## hasVerifyingObservers()

virtual OFBool DSRDocument::hasVerifyingObservers | ( |  | ) | const

virtual

check whether there are one or more verifying observers.

Note
  Not applicable to document types that use the Key Object Document Module.

Returns
  OFTrue if there is at least one verifying observer, OFFalse otherwise

## isFinalized()

virtual OFBool DSRDocument::isFinalized | ( |  | ) | const

virtual

check whether the document is finalized.

A new document is originally not finalized but can be finalized using the method finalizeDocument(). This flag is e.g. used to indicate whether the entire document is digitally signed and, therefore, each newly added verifying observer would corrupt all previous signatures.

Returns
  OFTrue if finalized, OFFalse otherwise

## isValid()

virtual OFBool DSRDocument::isValid | ( |  | ) |

virtual

check whether the current internal state is valid.

The SR document is valid if the corresponding document tree is valid and the SOP instance UID as well as the SOP class UID are not "empty".

Returns
  OFTrue if valid, OFFalse otherwise

## print()

virtual OFCondition DSRDocument::print | ( | STD_NAMESPACE ostream & | stream,
|  | const size_t | flags = 0 )

virtual

print current SR document to specified output stream.

The output format is identical to that of the dsrdump command line tool.

Parameters

  stream | output stream (e.g. COUT from "ofconsol.h")
  flags | optional flag used to customize the output (see DSRTypes::PF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## read()

virtual OFCondition DSRDocument::read | ( | DcmItem & | dataset,
|  | const size_t | flags = 0 )

virtual

read SR document from DICOM dataset.

Please note that the current document is also deleted if the reading process fails. If logging is enabled, the reason for any error might be obtained from the log output. Also warning and debug messages are reported if the respective logger is enabled.

Parameters

  dataset | reference to DICOM dataset from which the document should be read

  flags

  optional flag used to customize the reading process (see DSRTypes::RF_xxx). E.g. DSRTypes::RF_readDigitalSignatures indicates whether to read the digital signatures from the dataset or not. If set, the MACParametersSequence and the DigitalSignaturesSequence are read for the general document header (equivalent to top-level content item) and each content item of the document tree. If not removed manually (with DSRDocumentTree::removeSignatures()), the signatures are written back to the dataset when the write() method is called. Please note that the two signature sequences for any other sequence (e.g. VerifyingObserver or PredecessorDocuments) are never read.

Returns
  status, EC_Normal if successful, an error code otherwise

## readPatientData()

virtual OFCondition DSRDocument::readPatientData | ( | DcmItem & | dataset,
|  | const size_t | flags = 0 )

virtual

read patient data from DICOM dataset.

The list of data elements that are read can be found under "Patient Module" in the member variable section of this class. Other data is not changed, so be careful when using this method.

Parameters

  dataset | reference to DICOM dataset from which the data should be read
  flags | optional flag used to customize the reading process (see DSRTypes::RF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## readStudyData()

virtual OFCondition DSRDocument::readStudyData | ( | DcmItem & | dataset,
|  | const size_t | flags = 0 )

virtual

read study data from DICOM dataset.

Also reads patient data. The list of data elements that are read can be found under "Patient Module", "General Study Module" and "Patient Study Module" in the member variable section of this class. Other data is not changed, so be careful when using this method.

Parameters

  dataset | reference to DICOM dataset from which the data should be read
  flags | optional flag used to customize the reading process (see DSRTypes::RF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## readXML()

virtual OFCondition DSRDocument::readXML | ( | const OFString & | filename,
|  | const size_t | flags = 0 )

virtual

read SR document from XML file.

The format (Schema) of the XML document is expected to conform to the output format of the writeXML() method. In addition, the document can be validated against an XML Schema by setting the flag DSRTypes::XF_validateSchema. Digital signatures in the XML document are not yet supported. Please note that the current document is also deleted if the parsing process fails.

Parameters

  filename | name of the file from which the XML document is read ("-" for stdin)
  flags | optional flag used to customize the reading process (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## readXMLDocumentData()

OFCondition DSRDocument::readXMLDocumentData | ( | const DSRXMLDocument & | doc,
|  | DSRXMLCursor | cursor,
|  | const size_t | flags )

protected

read XML "document" data

Parameters

  doc | document containing the XML file content
  cursor | cursor pointing to the starting node
  flags | flag used to customize the reading process (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## readXMLDocumentHeader()

OFCondition DSRDocument::readXMLDocumentHeader | ( | DSRXMLDocument & | doc,
|  | DSRXMLCursor | cursor,
|  | const size_t | flags )

protected

read XML document header

Parameters

  doc | document containing the XML file content
  cursor | cursor pointing to the starting node
  flags | flag used to customize the reading process (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## readXMLInstanceData()

OFCondition DSRDocument::readXMLInstanceData | ( | const DSRXMLDocument & | doc,
|  | DSRXMLCursor | cursor,
|  | const size_t | flags )

protected

read XML "instance" data

Parameters

  doc | document containing the XML file content
  cursor | cursor pointing to the starting node
  flags | flag used to customize the reading process (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## readXMLPatientData()

OFCondition DSRDocument::readXMLPatientData | ( | const DSRXMLDocument & | doc,
|  | DSRXMLCursor | cursor,
|  | const size_t | flags )

protected

read XML "patient" data

Parameters

  doc | document containing the XML file content
  cursor | cursor pointing to the starting node
  flags | flag used to customize the reading process (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## readXMLSeriesData()

OFCondition DSRDocument::readXMLSeriesData | ( | const DSRXMLDocument & | doc,
|  | DSRXMLCursor | cursor,
|  | const size_t | flags )

protected

read XML "series" data

Parameters

  doc | document containing the XML file content
  cursor | cursor pointing to the starting node
  flags | flag used to customize the reading process (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## readXMLStudyData()

OFCondition DSRDocument::readXMLStudyData | ( | const DSRXMLDocument & | doc,
|  | DSRXMLCursor | cursor,
|  | const size_t | flags )

protected

read XML "study" data

Parameters

  doc | document containing the XML file content
  cursor | cursor pointing to the starting node
  flags | flag used to customize the reading process (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## readXMLVerifyingObserverData()

OFCondition DSRDocument::readXMLVerifyingObserverData | ( | const DSRXMLDocument & | doc,
|  | DSRXMLCursor | cursor,
|  | const size_t | flags )

protected

read XML verifying observer data

Parameters

  doc | document containing the XML file content
  cursor | cursor pointing to the starting node
  flags | flag used to customize the reading process (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## removeVerification()

virtual void DSRDocument::removeVerification | ( |  | ) |

virtual

remove verification information.

The list of verifying observers is cleared, the verification flag is set to UNVERIFIED and the finalized flag is reset (set to OFFalse). Normally, there should be no need to call this method. On the other hand, it is useful to guarantee a consistent state when processing documents which have not been created with this module/toolkit.

## renderHTML()

virtual OFCondition DSRDocument::renderHTML | ( | STD_NAMESPACE ostream & | stream,
|  | const size_t | flags = 0,
|  | const char * | styleSheet = NULL,
|  | const char * | urlPrefix = NULL )

virtual

render current SR document in HTML/XHTML format.

The output format is identical to that of the dsr2html command line tool.

Parameters

  stream | output stream to which the HTML/XHTML document is written
  flags | optional flag used to customize the output (see DSRTypes::HF_xxx)
  styleSheet | optional filename/URL of a Cascading Style Sheet (CSS)
  urlPrefix | optional URL prefix used for hyperlinks to referenced composite objects. If NULL, the default URL prefix is used, which is defined by DEFAULT_HTML_HYPERLINK_PREFIX_FOR_COMPOSITE_OBJECTS (http://localhost/dicom.cgi).

Note
  Please note that using the parameter 'styleSheet' or 'urlPrefix' can lead to security issues, as an attacker could misuse them to potentially inject dangerous content into the HTML/XHTML output. The values passed to these parameters are not checked, neither the URL and prefix nor the content of the specified CSS file.

Returns
  status, EC_Normal if successful, an error code otherwise

## renderHTMLPatientData()

void DSRDocument::renderHTMLPatientData | ( | STD_NAMESPACE ostream & | stream,
|  | const size_t | flags )

protected

render patient name, sex, birthdate and ID in HTML/XHTML format

Parameters

  stream | output stream to which the HTML/XHTML document is written
  flags | flag used to customize the output (see DSRTypes::HF_xxx)

## renderHTMLReferenceList() [1/2]

void DSRDocument::renderHTMLReferenceList | ( | STD_NAMESPACE ostream & | stream,
|  | DSRReferencedInstanceList & | refList,
|  | const size_t | flags,
|  | const char * | urlPrefix = NULL )

protected

render list of referenced SOP instances in HTML/XHTML format

Parameters

  stream | output stream to which the HTML/XHTML document is written
  refList | list of referenced SOP instances to be rendered
  flags | flag used to customize the output (see DSRTypes::HF_xxx)
  urlPrefix | optional URL prefix used for hyperlinks to referenced composite objects

## renderHTMLReferenceList() [2/2]

void DSRDocument::renderHTMLReferenceList | ( | STD_NAMESPACE ostream & | stream,
|  | DSRSOPInstanceReferenceList & | refList,
|  | const size_t | flags,
|  | const char * | urlPrefix = NULL )

protected

render list of referenced SOP instances in HTML/XHTML format

Parameters

  stream | output stream to which the HTML/XHTML document is written
  refList | list of referenced SOP instances to be rendered
  flags | flag used to customize the output (see DSRTypes::HF_xxx)
  urlPrefix | optional URL prefix used for hyperlinks to referenced composite objects

## setAccessionNumber()

virtual OFCondition DSRDocument::setAccessionNumber | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set accession number

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (SH) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setAcquisitionTimeSynchronized()

virtual OFCondition DSRDocument::setAcquisitionTimeSynchronized | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set acquisition time synchronized

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (CS) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setCompletionFlagDescription()

virtual OFCondition DSRDocument::setCompletionFlagDescription | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set completion flag description.

Note
  Not applicable to document types that use the Key Object Document Module.

Parameters

  value | explanation of the value that is set for completion flag. If an empty string is passed, the description is removed from the dataset (type 3).
  check | check 'value' for conformance with VR (LO) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setContentDate()

virtual OFCondition DSRDocument::setContentDate | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set content date

Parameters

  value | value to be set (single value only). If an empty string is passed, the current date is set when displaying or writing the document since the corresponding DICOM attribute is mandatory.
  check | check 'value' for conformance with VR (DA) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setContentTime()

virtual OFCondition DSRDocument::setContentTime | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set content time

Parameters

  value | value to be set (single value only). If an empty string is passed, the current time is set when displaying or writing the document since the corresponding DICOM attribute is mandatory.
  check | check 'value' for conformance with VR (TM) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setDeviceSerialNumber()

virtual OFCondition DSRDocument::setDeviceSerialNumber | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set device serial number

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (LO) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setInstanceNumber()

virtual OFCondition DSRDocument::setInstanceNumber | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set instance number

Parameters

  value | value to be set (single value only). If an empty string is passed, the value "1" is set when displaying or writing the document since the corresponding DICOM attribute is mandatory.
  check | check 'value' for conformance with VR (IS) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setIssuerOfPatientID()

virtual OFCondition DSRDocument::setIssuerOfPatientID | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set issuer of patient ID

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (LO) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setManufacturer()

virtual OFCondition DSRDocument::setManufacturer | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set manufacturer

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (LO) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setManufacturerModelName()

virtual OFCondition DSRDocument::setManufacturerModelName | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set manufacturer's model name

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (LO) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setPatientAge()

virtual OFCondition DSRDocument::setPatientAge | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set patient's age

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (AS) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setPatientBirthDate()

virtual OFCondition DSRDocument::setPatientBirthDate | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set patient's birth date

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (DA) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setPatientID()

virtual OFCondition DSRDocument::setPatientID | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set patient ID

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (LO) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setPatientName()

virtual OFCondition DSRDocument::setPatientName | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set patient's name

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (PN) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setPatientSex()

virtual OFCondition DSRDocument::setPatientSex | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set patient's sex

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (CS) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setPatientSize()

virtual OFCondition DSRDocument::setPatientSize | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set patient's size

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (DS) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setPatientWeight()

virtual OFCondition DSRDocument::setPatientWeight | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set patient's weight

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (DS) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setPreliminaryFlag()

virtual OFCondition DSRDocument::setPreliminaryFlag | ( | const E_PreliminaryFlag | flag | ) |

virtual

set document preliminary flag.

According to the DICOM standard, the concept of "completeness" is independent of the concept of "preliminary" or "final". Therefore, this flag can be specified separately.

Note
  Not applicable to document types that use the Key Object Document Module.

Parameters

  flag | preliminary flag to be set (use DSRTypes::PF_invalid to omit this optional value)

Returns
  status, EC_Normal if successful, an error code otherwise

## setProtocolName()

virtual OFCondition DSRDocument::setProtocolName | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set protocol name

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (LO) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setReferringPhysicianName()

virtual OFCondition DSRDocument::setReferringPhysicianName | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set referring physician's name

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (PN) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setSeriesDate()

virtual OFCondition DSRDocument::setSeriesDate | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set series date

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (DA) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setSeriesDescription()

virtual OFCondition DSRDocument::setSeriesDescription | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set series description

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (LO) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setSeriesNumber()

virtual OFCondition DSRDocument::setSeriesNumber | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set series number

Parameters

  value | value to be set (single value only). If an empty string is passed, the value "1" is set when displaying or writing the document since the corresponding DICOM attribute is mandatory.
  check | check 'value' for conformance with VR (IS) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setSeriesTime()

virtual OFCondition DSRDocument::setSeriesTime | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set series time

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (TM) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setSoftwareVersions()

virtual OFCondition DSRDocument::setSoftwareVersions | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set software version(s)

Parameters

  value | value to be set (possibly multi-valued) or "" for no value
  check | check 'value' for conformance with VR (LO) and VM (1-n) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setSpecificCharacterSet()

virtual OFCondition DSRDocument::setSpecificCharacterSet | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set specific character set.

The internal enumerated value is set accordingly. Please note that this method does not return an error if the given 'value' is not defined by the DICOM standard or not supported by this class, e.g. when no mapping to the character set names needed for HTML/XHTML or XML output is defined. If needed, check the return value of the method getSpecificCharacterSetType() for DSRTypes::CS_invalid or DSRTypes::CS_unknown after calling this method.

Parameters

  value | value to be set (single or multiple values) or "" for no value
  check | check 'value' for conformance with VR (CS) and VM (1-n) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setSpecificCharacterSetType()

virtual OFCondition DSRDocument::setSpecificCharacterSetType | ( | const E_CharacterSet | characterSet | ) |

virtual

set specific character set type.

The DICOM defined term (see member variable SpecificCharacterSet) is set accordingly.

Parameters

  characterSet | specific character set to be set (use DSRTypes::CS_invalid to reset to the default value, which is "unspecified")

Returns
  status, EC_Normal if successful, an error code otherwise

## setStudyDate()

virtual OFCondition DSRDocument::setStudyDate | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set study date

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (DA) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setStudyDescription()

virtual OFCondition DSRDocument::setStudyDescription | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set study description

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (LO) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setStudyID()

virtual OFCondition DSRDocument::setStudyID | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set study ID

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (SH) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setStudyTime()

virtual OFCondition DSRDocument::setStudyTime | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set study time

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (TM) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setSynchronizationFrameOfReferenceUID()

virtual OFCondition DSRDocument::setSynchronizationFrameOfReferenceUID | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set synchronization frame of reference UID

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (UI) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setSynchronizationTrigger()

virtual OFCondition DSRDocument::setSynchronizationTrigger | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set synchronization trigger

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (CS) and VM (1) if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## setTimezoneOffsetFromUTC()

virtual OFCondition DSRDocument::setTimezoneOffsetFromUTC | ( | const OFString & | value,
|  | const OFBool | check = OFTrue )

virtual

set timezone offset from UTC

Parameters

  value | value to be set (single value only) or "" for no value
  check | check 'value' for conformance with VR (SH) and VM (1) if enabled. Please note that it is not checked whether the 'value' conforms to the requirements of a valid timezone offset (see DICOM PS3.3).

Returns
  status, EC_Normal if successful, an error code otherwise

## setTree()

virtual OFCondition DSRDocument::setTree | ( | const DSRDocumentTree & | tree | ) |

virtual

set document tree.

Replace the currently stored document tree with the given one. Please note that the given 'tree' is checked before setting it, i.e. only a valid document tree is accepted. However, a new SOP instance is never created. If needed, this has to be done with createNewSOPInstance() in addition to or with createNewDocument() before this method is called.

Parameters

  tree | document tree to be set (content will be copied)

Returns
  status, EC_Normal if successful, an error code otherwise

## setTreeFromRootTemplate()

virtual OFCondition DSRDocument::setTreeFromRootTemplate | ( | DSRRootTemplate & | rootTemplate,
|  | const OFBool | expandTree = OFTrue )

virtual

set document tree from root template.

Replace the currently stored document tree with the one from the given root template. By default, this method expands the tree, i.e. instances of DSRIncludedTemplateTreeNode that were added to the tree with DSRDocumentSubTree::includeTemplate() are replaced by their content, i.e. by the internally managed subtree. Please note that the additional comments on the above setTree() method also apply.

Parameters

  rootTemplate | template specifying the document tree to be set (content will be copied). This parameter cannot be "const" because of DSRRootTemplate::getTree(), which is called internally and which modifies the tree.
  expandTree | optional flag that allows for disabling the expanding of the document tree before setting it. Please note that various output methods like write() or renderHTML() do not yet work on such trees.

Returns
  status, EC_Normal if successful, an error code otherwise

## updateAttributes()

void DSRDocument::updateAttributes | ( | const OFBool | updateAll = OFTrue,
|  | const OFBool | verboseMode = OFTrue )

protected

update various DICOM attributes.

(e.g. set the modality and SOP class UID, generate a new Study, Series and SOP instance UID if required, set date/time values, etc.)

Parameters

  updateAll | flag indicating whether all DICOM attributes should be updated or only the IOD-specific ones. (e.g. set DICOM defined terms from enum values)
  verboseMode | report (more) processing details to the logger if enabled (default)

## verifyDocument() [1/2]

virtual OFCondition DSRDocument::verifyDocument | ( | const OFString & | observerName,
|  | const DSRCodedEntryValue & | observerCode,
|  | const OFString & | organization,
|  | const OFString & | dateTime = "",
|  | const OFBool | check = OFTrue )

virtual

verify the current document by a specific observer.

A document can be verified more than once. The observer information is added to a sequence stored in the dataset. The verification flag is automatically set to VERIFIED (if not already done) and the finalized flag is reset (set to OFFalse). Please note that only completed documents (see completion flag) can be verified and that a new SOP instance UID has to be generated (manually) according to the DICOM standard when creating a dataset/file from this document.

Note
  Not applicable to document types that use the Key Object Document Module.

Parameters

  observerName | name of the person who has verified this document (required, VR=PN)
  observerCode | code identifying the verifying observer (optional, see previous method)
  organization | name of the organization to which the observer belongs (required, VR=LO)
  dateTime | verification date time (optional). If empty/absent the current date and time are used.
  check | check 'observerName', 'observerCode', 'organization' and 'dateTime' for conformance with VR and VM if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## verifyDocument() [2/2]

virtual OFCondition DSRDocument::verifyDocument | ( | const OFString & | observerName,
|  | const OFString & | organization,
|  | const OFString & | dateTime = "",
|  | const OFBool | check = OFTrue )

virtual

verify the current document by a specific observer.

A document can be verified more than once. The observer information is added to a sequence stored in the dataset. The verification flag is automatically set to VERIFIED (if not already done) and the finalized flag is reset (set to OFFalse). Please note that only completed documents (see completion flag) can be verified and that a new SOP instance UID has to be generated (manually) according to the DICOM standard when creating a dataset/file from this document.

Note
  Not applicable to document types that use the Key Object Document Module.

Parameters

  observerName | name of the person who has verified this document (required, VR=PN)
  organization | name of the organization to which the observer belongs (required, VR=LO)
  dateTime | verification date time (optional). If empty/absent the current date and time are used.
  check | check 'observerName', 'organization' and 'dateTime' for conformance with VR and VM if enabled

Returns
  status, EC_Normal if successful, an error code otherwise

## write()

virtual OFCondition DSRDocument::write | ( | DcmItem & | dataset,
|  | DcmStack * | markedItems = NULL )

virtual

write current SR document to DICOM dataset.

Please note that the ContentTemplateSequence for the root content item is not written automatically for particular SOP Classes (e.g. Key Object Selection Document). Instead, the template identification has to be set manually for the root CONTAINER (see DSRDocumentTreeNode::setTemplateIdentification()). This is because the template constraints cannot be checked yet. If logging is enabled, warning and debug messages are reported to the log output.

Parameters

  dataset | reference to DICOM dataset to which the current document should be written. The 'dataset' is not cleared before writing to it!
  markedItems | optional stack where pointers to all 'marked' content items (DICOM datasets/items) are added to during the write process. Can be used to digitally sign parts of the document tree.

Returns
  status, EC_Normal if successful, an error code otherwise

## writeXML()

virtual OFCondition DSRDocument::writeXML | ( | STD_NAMESPACE ostream & | stream,
|  | const size_t | flags = 0 )

virtual

write current SR document in XML format.

The output format is identical to that of the dsr2xml command line tool. Digital signatures in the XML document are not yet supported.

Parameters

  stream | output stream to which the XML document is written
  flags | optional flag used to customize the output (see DSRTypes::XF_xxx)

Returns
  status, EC_Normal if successful, an error code otherwise

## Member Data Documentation

## PredecessorDocuments

DSRSOPInstanceReferenceList DSRDocument::PredecessorDocuments

private

Author Observer Sequence: (SQ, 1-n, 3).

Participant Sequence: (SQ, 1-n, 3) Custodial Organization Sequence: (SQ, 1, 3) Predecessor Documents Sequence: (SQ, 1-n, 1C)

## ReferencedPerformedProcedureStep

DcmSequenceOfItems DSRDocument::ReferencedPerformedProcedureStep

private

Series Description Code Sequence: (SQ, 1, 3).

Referenced Performed Procedure Step Sequence: (SQ, 1, 2)

## TimezoneOffsetFromUTC

DcmShortString DSRDocument::TimezoneOffsetFromUTC

private

Context Group Identification Sequence: (SQ, 1-n, 3).

Mapping Resource Identification Sequence: (SQ, 1-n, 3) Timezone Offset from UTC: (SH, 1, 3)

The documentation for this class was generated from the following file:

- dcmsr/include/dcmtk/dcmsr/dsrdoc.h

Generated on for DCMTK Version 3.7.0 by Doxygen 1.15.0